#ifndef PSURFACE_SMOOTHER_H
#define PSURFACE_SMOOTHER_H

#include "HxParamToolBox.h"
#include "DomainPolygon.h"

#include "psurfaceAPI.h"

namespace psurface {

template <int dim, class ctype> class PSurface;

template <class ctype>
class PSURFACE_API PSurfaceSmoother
{
    
public:

    ///
    static void applyEdgeRelaxation(PSurface<2,ctype>* psurface, int edge, 
                                    bool keepPatches, std::vector<unsigned int>& nodeStack);

    ///
    void applyVertexRelaxation();

    ///
    static void applyHorizontalRelaxation(DomainPolygon& quadri, PSurface<2,ctype>* psurface);
    
private:

    static void moveSubGraph(int startingNode, DomainPolygon& from, int centerNode);

};

}

#endif
